Cabal-3.10.1.0: A framework for packaging Haskell software

Safe Haskell | Safe-Inferred
Language | Haskell2010

Distribution.Backpack.ModSubst

Description

A type class `ModSubst` for objects which can have `ModuleSubst` applied to them.

See also https://github.com/ezyang/ghc-proposals/blob/backpack/proposals/0000-backpack.rst

Synopsis

- class ModSubst a where
  - modSubst :: OpenModuleSubst -> a -> a

# Documentation

class ModSubst a where Source #

Applying module substitutions to semantic objects.

Methods

modSubst :: OpenModuleSubst -> a -> a Source #

#### Instances

Instances details

ModSubst ModuleShape Source # |
Instance details Defined in Distribution.Backpack.ModuleShape Methods modSubst :: OpenModuleSubst -> ModuleShape -> ModuleShape Source #
ModSubst OpenModule Source # |
Instance details Defined in Distribution.Backpack.ModSubst Methods modSubst :: OpenModuleSubst -> OpenModule -> OpenModule Source #
ModSubst OpenUnitId Source # |
Instance details Defined in Distribution.Backpack.ModSubst Methods modSubst :: OpenModuleSubst -> OpenUnitId -> OpenUnitId Source #
ModSubst (Set ModuleName) Source # |
Instance details Defined in Distribution.Backpack.ModSubst Methods modSubst :: OpenModuleSubst -> Set ModuleName -> Set ModuleName Source #
ModSubst a => ModSubst [a] Source # |
Instance details Defined in Distribution.Backpack.ModSubst Methods modSubst :: OpenModuleSubst -> [a] -> [a] Source #
ModSubst a => ModSubst (Map k a) Source # |
Instance details Defined in Distribution.Backpack.ModSubst Methods modSubst :: OpenModuleSubst -> Map k a -> Map k a Source #
ModSubst a => ModSubst (k, a) Source # |
Instance details Defined in Distribution.Backpack.ModSubst Methods modSubst :: OpenModuleSubst -> (k, a) -> (k, a) Source #